
#include "FM_ADC.h"

/* adcɼתı */
/* ׿ϵͳѹ */
static float P_PwrOn_Voltage;
/* صĵѹ */
static float P_In_Voltage;
/* صĵ */
static float P_In_Current;

/* οѹĴС */
#define referenceVoltage 3.3f

/**
  * @brief  ɼadcУ׼
  * @param  val ɼadc
  * @retval     У׼adc
  */
static uint16_t Get_ConversionVal(int16_t val)
{
    if((val + Calibrattion_Val) < 0 || val == 0)
        return 0;
    if((Calibrattion_Val + val) > 4095 || val == 4095)
        return 4095;
    return (val + Calibrattion_Val);
}

/**
  * @brief  ʼadc
  * @param
  * @retval
  */
void FM_ADC_Init(void)
{
    HD_ADC_InIt();
    ADC_DMA_Init();
    startAdcCapture();
}

/**
  * @brief  ӡadcɵ
  * @param
  * @retval
  */
void printf_adc_data(void)
{
    printf("adc : %d, %d, %d\n", adcData[0], adcData[1], adcData[2]);
    printf("getSOCPwrOnVoltage: %d\n", (int)(getSOCPwrOnVoltage() * 1000.0f));
    printf("getInCurrent: %d\n", (int)(getInCurrent() * 1000.0f));
    printf("getInVoltage: %d\n", (int)(getInVoltage() * 1000.0f));
}

/**
  * @brief  ʼתı
  * @param
  * @retval
  */
void proportionalInt(void)
{
    P_PwrOn_Voltage = referenceVoltage / 4095.0f;
    P_In_Voltage = ((100.0f + 10.0f) / 10.0f) * referenceVoltage / 4095.0f;
    P_In_Current = ((1.0f / 50.0f) / (0.01f)) * referenceVoltage / 4095.0f;
}

/**
  * @brief  õsocѹ
  * @param
  * @retval
  */
float getSOCPwrOnVoltage(void)
{
    return (Get_ConversionVal(adcData[0]) * P_PwrOn_Voltage);
}

/**
  * @brief  õغӵĵ
  * @param
  * @retval
  */
float getInCurrent(void)
{
    return (Get_ConversionVal(adcData[1]) * P_In_Current);
}

/**
  * @brief  õغӵĵѹ
  * @param
  * @retval
  */
float getInVoltage(void)
{
    return (Get_ConversionVal(adcData[2]) * P_In_Voltage);
}