### 测试

串口中断发送通过测试

spi_flash读写通过测试

对智能模块通信串口，阻塞发送数据通过测试。







### 问题

##### 串口中断

25/02/24

在freerots环境下，中断不生效

###### 解决

> 25/02/25
>
> 需要启动freerots任务
>
> 同时中断部分
>
> ```c
> void UART5_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
> ```
>
> 变为
>
> ```c
> void UART5_IRQHandler(void) __attribute__((interrupt()));
> ```
>
> 其他中断同上，由硬件压栈变为软件压栈

